// Copyright (C) 2021-2024 Bundesministerium des Innern und für Heimat, Referat DG II 6, Maßnahmen Enterprise Resource Management und Elektronische Verwaltungsarbeit
//
// SPDX-License-Identifier: MPL-2.0

// tslint:disable
/**
 * eGesetzgebung Platform
 * This is the rest interface offered by the eGesetzgebung Platform backend.  Please provide __JW Access Token__ using button \'Authorize\' to access protected endpoints. Use the following instructions to get token:  1. on CMD/Bash/Terminal: ```curl -d \"client_id=user-management\" -d \"client_secret=INSERT_IAM_SECRET\" -d \"grant_type=password&username=INSERT_USER_EMAIL&password=INSERT_USER_PASSWORD\" \"INSERT_IAM_URL/realms/bund/protocol/openid-connect/token\"``` 2. copy access_token (without quotes, you can use jq or other tools to extract this value automatically) 3. insert value into \'JWToken\' field under \'Authorize\' and press \'Authorize\' 4. now you should have access to user protected endpoint  __FYI:__ token expires after 60 seconds. On non-production systems only a warning is displayed so you can work smoothly, but on production systems you have to frequently provide a new token.
 *
 * The version of the OpenAPI document: 9.0.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import type { Observable } from 'rxjs';
import type { AjaxResponse } from 'rxjs/ajax';
import { BaseAPI, throwIfNullOrUndefined, encodeURI } from '../runtime';
import type { OperationOpts, HttpHeaders } from '../runtime';
import type {
    AbstimmungEntityDTO,
    AbstimmungEntityResponseDTO,
    AbstimmungInfoDTO,
    AbstimmungTableDTOs,
    AbstimmungsanfrageDTO,
    AnfrageCreateDTO,
    AnfrageEntityModifyDTO,
    AnfrageEntityResponseDTO,
    AnfrageTableDTOs,
    ArchivTableDTOs,
    EntwurfTableDTOs,
    LetzteHausabstimmungDTO,
    MitzeichnungTableDTOs,
    PaginierungDTO,
    RueckmeldungBkAmtType,
    RueckmeldungBmjType,
    TeilnehmerEntityModifyDTO,
    TeilnehmerEntityResponseDTO,
    TeilnehmerWithFilesEntityListResponseDTO,
    TeilnehmerWithFilesEntityResponseDTO,
    UserEntityResponseDTO,
} from '../models';

export interface AddTeilnehmerRequest {
    abstimmungId: string;
}

export interface ArchiveAbstimmungRequest {
    id: string;
}

export interface ArchiveAnfrageRequest {
    anfrageId: string;
}

export interface CancelTeilnehmerRequestRequest {
    id: string;
    userId: string;
}

export interface CreateAbstimmungRequest {
    abstimmungEntityDTO: AbstimmungEntityDTO;
}

export interface CreateAbstimmungsanfrageRequest {
    id: string;
    abstimmungsanfrageDTO: AbstimmungsanfrageDTO;
}

export interface CreateAnfrageRequest {
    abstimmungId: string;
    anfrageCreateDTO: AnfrageCreateDTO;
}

export interface DeleteAbstimmungRequest {
    id: string;
}

export interface DeleteTeilnehmerRequest {
    id: string;
    userId: string;
}

export interface GetAbstimmungRequest {
    id: string;
}

export interface GetAbstimmungenRequest {
    isFilterNeeded: boolean;
    paginierungDTO: PaginierungDTO;
}

export interface GetAbstimmungsentwurfRequest {
    metadataId: string;
}

export interface GetAbstimmungsinfoRequest {
    id: string;
}

export interface GetAnfragenRequest {
    isFilterNeeded: boolean;
    paginierungDTO: PaginierungDTO;
}

export interface GetArchiv1Request {
    isFilterNeeded: boolean;
    paginierungDTO: PaginierungDTO;
}

export interface GetEntwuerfe1Request {
    isFilterNeeded: boolean;
    paginierungDTO: PaginierungDTO;
}

export interface GetErstellerRequest {
    id: string;
}

export interface GetLetzteHausabstimmungRequest {
    rvId: string;
}

export interface GetMitzeichnungAbstimmungenRequest {
    isFilterNeeded: boolean;
    paginierungDTO: PaginierungDTO;
}

export interface GetTeilnehmerRequest {
    id: string;
}

export interface GetTeilnehmer1Request {
    id: string;
    userId: string;
}

export interface GetUnterabstimmungenRequest {
    isFilterNeeded: boolean;
    paginierungDTO: PaginierungDTO;
}

export interface GetUnterabstimmungsentwurfRequest {
    metadataId: string;
}

export interface ModifyAbstimmungRequest {
    id: string;
    abstimmungEntityDTO: AbstimmungEntityDTO;
}

export interface ModifyAnfrageRequest {
    anfrageId: string;
    anfrageEntityModifyDTO: AnfrageEntityModifyDTO;
}

export interface ModifyRueckmeldungBkAmtRequest {
    id: string;
    rueckmeldungType: RueckmeldungBkAmtType;
}

export interface ModifyRueckmeldungBmjRequest {
    id: string;
    rueckmeldungType: RueckmeldungBmjType;
}

export interface ModifyTeilnehmerRequest {
    id: string;
    teilnehmerEntityModifyDTO: TeilnehmerEntityModifyDTO;
}

export interface ModifyTeilnehmerRequestRequest {
    anfrageId: string;
    anfrageEntityModifyDTO: AnfrageEntityModifyDTO;
}

export interface SetTeilnehmerInCcRequest {
    id: string;
    userId: string;
}

/**
 * no description
 */
export class AbstimmungControllerApi extends BaseAPI {

    /**
     * Fügt einen Teilnehmer zu einer laufenden Abstimmung hinzu
     * Teilnehmer hinzufügen
     */
    addTeilnehmer({ abstimmungId }: AddTeilnehmerRequest): Observable<void>
    addTeilnehmer({ abstimmungId }: AddTeilnehmerRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    addTeilnehmer({ abstimmungId }: AddTeilnehmerRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(abstimmungId, 'abstimmungId', 'addTeilnehmer');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/abstimmung/{abstimmungId}/teilnehmer/add'.replace('{abstimmungId}', encodeURI(abstimmungId)),
            method: 'POST',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Archiviert eine Abstimmung
     * Abstimmung archivieren (E+T)
     */
    archiveAbstimmung({ id }: ArchiveAbstimmungRequest): Observable<void>
    archiveAbstimmung({ id }: ArchiveAbstimmungRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    archiveAbstimmung({ id }: ArchiveAbstimmungRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'archiveAbstimmung');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/abstimmung/{id}/archivieren'.replace('{id}', encodeURI(id)),
            method: 'PUT',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Archiviert eine Anfrage
     * Anfrage archivieren (T)
     */
    archiveAnfrage({ anfrageId }: ArchiveAnfrageRequest): Observable<void>
    archiveAnfrage({ anfrageId }: ArchiveAnfrageRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    archiveAnfrage({ anfrageId }: ArchiveAnfrageRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(anfrageId, 'anfrageId', 'archiveAnfrage');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/abstimmung/{anfrageId}/anfrage/archivieren'.replace('{anfrageId}', encodeURI(anfrageId)),
            method: 'PUT',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Teilnehemer zieht die Teilnahmeanfrage an einer Abstimmung zurück
     * Teilnahmeanfrage zurückziehen
     */
    cancelTeilnehmerRequest({ id, userId }: CancelTeilnehmerRequestRequest): Observable<void>
    cancelTeilnehmerRequest({ id, userId }: CancelTeilnehmerRequestRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    cancelTeilnehmerRequest({ id, userId }: CancelTeilnehmerRequestRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'cancelTeilnehmerRequest');
        throwIfNullOrUndefined(userId, 'userId', 'cancelTeilnehmerRequest');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/abstimmung/{id}/teilnahmeanfrage/{userId}/cancel'.replace('{id}', encodeURI(id)).replace('{userId}', encodeURI(userId)),
            method: 'PUT',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Leitet eine neue Abstimmung ein
     * POST ABSTIMMUNG
     */
    createAbstimmung({ abstimmungEntityDTO }: CreateAbstimmungRequest): Observable<AbstimmungEntityResponseDTO>
    createAbstimmung({ abstimmungEntityDTO }: CreateAbstimmungRequest, opts?: OperationOpts): Observable<AjaxResponse<AbstimmungEntityResponseDTO>>
    createAbstimmung({ abstimmungEntityDTO }: CreateAbstimmungRequest, opts?: OperationOpts): Observable<AbstimmungEntityResponseDTO | AjaxResponse<AbstimmungEntityResponseDTO>> {
        throwIfNullOrUndefined(abstimmungEntityDTO, 'abstimmungEntityDTO', 'createAbstimmung');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<AbstimmungEntityResponseDTO>({
            url: '/abstimmung',
            method: 'POST',
            headers,
            body: abstimmungEntityDTO,
        }, opts?.responseOpts);
    };

    /**
     * Fragt beim Ersteller eine Abstimmungsteilnahme an
     * POST ABSTIMMUNG PARTICIPATION REQUEST
     */
    createAbstimmungsanfrage({ id, abstimmungsanfrageDTO }: CreateAbstimmungsanfrageRequest): Observable<void>
    createAbstimmungsanfrage({ id, abstimmungsanfrageDTO }: CreateAbstimmungsanfrageRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    createAbstimmungsanfrage({ id, abstimmungsanfrageDTO }: CreateAbstimmungsanfrageRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'createAbstimmungsanfrage');
        throwIfNullOrUndefined(abstimmungsanfrageDTO, 'abstimmungsanfrageDTO', 'createAbstimmungsanfrage');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/abstimmung/{id}/teilnahmeanfrage'.replace('{id}', encodeURI(id)),
            method: 'POST',
            headers,
            body: abstimmungsanfrageDTO,
        }, opts?.responseOpts);
    };

    /**
     * Erstellt eine Anfrage (bspw. zur Fristverlaengerung) für eine Abstimmung.
     * RENEW DEADLINE
     */
    createAnfrage({ abstimmungId, anfrageCreateDTO }: CreateAnfrageRequest): Observable<AnfrageEntityResponseDTO>
    createAnfrage({ abstimmungId, anfrageCreateDTO }: CreateAnfrageRequest, opts?: OperationOpts): Observable<AjaxResponse<AnfrageEntityResponseDTO>>
    createAnfrage({ abstimmungId, anfrageCreateDTO }: CreateAnfrageRequest, opts?: OperationOpts): Observable<AnfrageEntityResponseDTO | AjaxResponse<AnfrageEntityResponseDTO>> {
        throwIfNullOrUndefined(abstimmungId, 'abstimmungId', 'createAnfrage');
        throwIfNullOrUndefined(anfrageCreateDTO, 'anfrageCreateDTO', 'createAnfrage');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<AnfrageEntityResponseDTO>({
            url: '/abstimmung/{abstimmungId}/anfrage'.replace('{abstimmungId}', encodeURI(abstimmungId)),
            method: 'POST',
            headers,
            body: anfrageCreateDTO,
        }, opts?.responseOpts);
    };

    /**
     * Löscht einen Abstimmungsentwurf
     * Abstimmung löschen (E)
     */
    deleteAbstimmung({ id }: DeleteAbstimmungRequest): Observable<void>
    deleteAbstimmung({ id }: DeleteAbstimmungRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    deleteAbstimmung({ id }: DeleteAbstimmungRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'deleteAbstimmung');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/abstimmung/{id}'.replace('{id}', encodeURI(id)),
            method: 'DELETE',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Entfernt einen Teilnehmer aus einer Abstimmung
     * Teilnehmer entfernen (E)
     */
    deleteTeilnehmer({ id, userId }: DeleteTeilnehmerRequest): Observable<void>
    deleteTeilnehmer({ id, userId }: DeleteTeilnehmerRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    deleteTeilnehmer({ id, userId }: DeleteTeilnehmerRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'deleteTeilnehmer');
        throwIfNullOrUndefined(userId, 'userId', 'deleteTeilnehmer');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/abstimmung/{id}/teilnehmer/{userId}'.replace('{id}', encodeURI(id)).replace('{userId}', encodeURI(userId)),
            method: 'DELETE',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Lädt eine Abstimmung
     * GET ABSTIMMUNG
     */
    getAbstimmung({ id }: GetAbstimmungRequest): Observable<AbstimmungEntityResponseDTO>
    getAbstimmung({ id }: GetAbstimmungRequest, opts?: OperationOpts): Observable<AjaxResponse<AbstimmungEntityResponseDTO>>
    getAbstimmung({ id }: GetAbstimmungRequest, opts?: OperationOpts): Observable<AbstimmungEntityResponseDTO | AjaxResponse<AbstimmungEntityResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'getAbstimmung');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<AbstimmungEntityResponseDTO>({
            url: '/abstimmung/{id}'.replace('{id}', encodeURI(id)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Liefert die Liste der Hauptabstimmungen des Anwenders (»Meine Abstimmungen«).
     * Lädt Ersteller Hauptabstimmungen.
     */
    getAbstimmungen({ isFilterNeeded, paginierungDTO }: GetAbstimmungenRequest): Observable<AbstimmungTableDTOs>
    getAbstimmungen({ isFilterNeeded, paginierungDTO }: GetAbstimmungenRequest, opts?: OperationOpts): Observable<AjaxResponse<AbstimmungTableDTOs>>
    getAbstimmungen({ isFilterNeeded, paginierungDTO }: GetAbstimmungenRequest, opts?: OperationOpts): Observable<AbstimmungTableDTOs | AjaxResponse<AbstimmungTableDTOs>> {
        throwIfNullOrUndefined(isFilterNeeded, 'isFilterNeeded', 'getAbstimmungen');
        throwIfNullOrUndefined(paginierungDTO, 'paginierungDTO', 'getAbstimmungen');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<AbstimmungTableDTOs>({
            url: '/abstimmung/abstimmungen/{isFilterNeeded}'.replace('{isFilterNeeded}', encodeURI(isFilterNeeded)),
            method: 'POST',
            headers,
            body: paginierungDTO,
        }, opts?.responseOpts);
    };

    /**
     * Lädt den aktuellen Abstimmungsentwurf oder gibt einen neuen vorgefüllten Entwurf zurück
     * GET ABSTIMMUNGSENTWURF
     */
    getAbstimmungsentwurf({ metadataId }: GetAbstimmungsentwurfRequest): Observable<AbstimmungEntityResponseDTO>
    getAbstimmungsentwurf({ metadataId }: GetAbstimmungsentwurfRequest, opts?: OperationOpts): Observable<AjaxResponse<AbstimmungEntityResponseDTO>>
    getAbstimmungsentwurf({ metadataId }: GetAbstimmungsentwurfRequest, opts?: OperationOpts): Observable<AbstimmungEntityResponseDTO | AjaxResponse<AbstimmungEntityResponseDTO>> {
        throwIfNullOrUndefined(metadataId, 'metadataId', 'getAbstimmungsentwurf');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<AbstimmungEntityResponseDTO>({
            url: '/abstimmung/abstimmungsentwurf/{metadataId}'.replace('{metadataId}', encodeURI(metadataId)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Lädt eine kompakte Info oder Zusammenfassung einer Abstimmung (auch nutzbar für Nichtteilnehmer!)
     * GET ABSTIMMUNG INFO
     */
    getAbstimmungsinfo({ id }: GetAbstimmungsinfoRequest): Observable<AbstimmungInfoDTO>
    getAbstimmungsinfo({ id }: GetAbstimmungsinfoRequest, opts?: OperationOpts): Observable<AjaxResponse<AbstimmungInfoDTO>>
    getAbstimmungsinfo({ id }: GetAbstimmungsinfoRequest, opts?: OperationOpts): Observable<AbstimmungInfoDTO | AjaxResponse<AbstimmungInfoDTO>> {
        throwIfNullOrUndefined(id, 'id', 'getAbstimmungsinfo');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<AbstimmungInfoDTO>({
            url: '/abstimmung/{id}/info'.replace('{id}', encodeURI(id)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Liefert die Liste der Anfragen an den Anwender (»Anfrage«).
     * Lädt Anfragen.
     */
    getAnfragen({ isFilterNeeded, paginierungDTO }: GetAnfragenRequest): Observable<AnfrageTableDTOs>
    getAnfragen({ isFilterNeeded, paginierungDTO }: GetAnfragenRequest, opts?: OperationOpts): Observable<AjaxResponse<AnfrageTableDTOs>>
    getAnfragen({ isFilterNeeded, paginierungDTO }: GetAnfragenRequest, opts?: OperationOpts): Observable<AnfrageTableDTOs | AjaxResponse<AnfrageTableDTOs>> {
        throwIfNullOrUndefined(isFilterNeeded, 'isFilterNeeded', 'getAnfragen');
        throwIfNullOrUndefined(paginierungDTO, 'paginierungDTO', 'getAnfragen');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<AnfrageTableDTOs>({
            url: '/abstimmung/anfragen/{isFilterNeeded}'.replace('{isFilterNeeded}', encodeURI(isFilterNeeded)),
            method: 'POST',
            headers,
            body: paginierungDTO,
        }, opts?.responseOpts);
    };

    /**
     * Liefert die Archivliste des Anwenders (»Archiv«).
     * Lädt archivierte Abstimmungen.
     */
    getArchiv1({ isFilterNeeded, paginierungDTO }: GetArchiv1Request): Observable<ArchivTableDTOs>
    getArchiv1({ isFilterNeeded, paginierungDTO }: GetArchiv1Request, opts?: OperationOpts): Observable<AjaxResponse<ArchivTableDTOs>>
    getArchiv1({ isFilterNeeded, paginierungDTO }: GetArchiv1Request, opts?: OperationOpts): Observable<ArchivTableDTOs | AjaxResponse<ArchivTableDTOs>> {
        throwIfNullOrUndefined(isFilterNeeded, 'isFilterNeeded', 'getArchiv1');
        throwIfNullOrUndefined(paginierungDTO, 'paginierungDTO', 'getArchiv1');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<ArchivTableDTOs>({
            url: '/abstimmung/archiv/{isFilterNeeded}'.replace('{isFilterNeeded}', encodeURI(isFilterNeeded)),
            method: 'POST',
            headers,
            body: paginierungDTO,
        }, opts?.responseOpts);
    };

    /**
     * Liefert die Liste der Entwürfe des Anwenders (»Entwürfe«).
     * Lädt Ersteller Entwürfe.
     */
    getEntwuerfe1({ isFilterNeeded, paginierungDTO }: GetEntwuerfe1Request): Observable<EntwurfTableDTOs>
    getEntwuerfe1({ isFilterNeeded, paginierungDTO }: GetEntwuerfe1Request, opts?: OperationOpts): Observable<AjaxResponse<EntwurfTableDTOs>>
    getEntwuerfe1({ isFilterNeeded, paginierungDTO }: GetEntwuerfe1Request, opts?: OperationOpts): Observable<EntwurfTableDTOs | AjaxResponse<EntwurfTableDTOs>> {
        throwIfNullOrUndefined(isFilterNeeded, 'isFilterNeeded', 'getEntwuerfe1');
        throwIfNullOrUndefined(paginierungDTO, 'paginierungDTO', 'getEntwuerfe1');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<EntwurfTableDTOs>({
            url: '/abstimmung/entwuerfe/{isFilterNeeded}'.replace('{isFilterNeeded}', encodeURI(isFilterNeeded)),
            method: 'POST',
            headers,
            body: paginierungDTO,
        }, opts?.responseOpts);
    };

    /**
     * Lädt den Ersteller einer Abstimmung
     * GET ERSTELLER
     */
    getErsteller({ id }: GetErstellerRequest): Observable<UserEntityResponseDTO>
    getErsteller({ id }: GetErstellerRequest, opts?: OperationOpts): Observable<AjaxResponse<UserEntityResponseDTO>>
    getErsteller({ id }: GetErstellerRequest, opts?: OperationOpts): Observable<UserEntityResponseDTO | AjaxResponse<UserEntityResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'getErsteller');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<UserEntityResponseDTO>({
            url: '/abstimmung/{id}/ersteller'.replace('{id}', encodeURI(id)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Lädt die letzte Hausabstimmung des aktuellen Users mit dem angegebenen Regelungsvorhaben
     * GET LETZTE HAUSABSTIMMUNG
     */
    getLetzteHausabstimmung({ rvId }: GetLetzteHausabstimmungRequest): Observable<LetzteHausabstimmungDTO>
    getLetzteHausabstimmung({ rvId }: GetLetzteHausabstimmungRequest, opts?: OperationOpts): Observable<AjaxResponse<LetzteHausabstimmungDTO>>
    getLetzteHausabstimmung({ rvId }: GetLetzteHausabstimmungRequest, opts?: OperationOpts): Observable<LetzteHausabstimmungDTO | AjaxResponse<LetzteHausabstimmungDTO>> {
        throwIfNullOrUndefined(rvId, 'rvId', 'getLetzteHausabstimmung');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<LetzteHausabstimmungDTO>({
            url: '/abstimmung/letzte-hausabstimmung/{rvId}'.replace('{rvId}', encodeURI(rvId)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Liefert die Liste der Abstimmungen bei denen der Anwender um Mitzeichnung gebeten wird (»Bitte um Mitzeichnung«).
     * Lädt Abstimmungen zur Mitzeichnung.
     */
    getMitzeichnungAbstimmungen({ isFilterNeeded, paginierungDTO }: GetMitzeichnungAbstimmungenRequest): Observable<MitzeichnungTableDTOs>
    getMitzeichnungAbstimmungen({ isFilterNeeded, paginierungDTO }: GetMitzeichnungAbstimmungenRequest, opts?: OperationOpts): Observable<AjaxResponse<MitzeichnungTableDTOs>>
    getMitzeichnungAbstimmungen({ isFilterNeeded, paginierungDTO }: GetMitzeichnungAbstimmungenRequest, opts?: OperationOpts): Observable<MitzeichnungTableDTOs | AjaxResponse<MitzeichnungTableDTOs>> {
        throwIfNullOrUndefined(isFilterNeeded, 'isFilterNeeded', 'getMitzeichnungAbstimmungen');
        throwIfNullOrUndefined(paginierungDTO, 'paginierungDTO', 'getMitzeichnungAbstimmungen');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<MitzeichnungTableDTOs>({
            url: '/abstimmung/mitzeichnungen/{isFilterNeeded}'.replace('{isFilterNeeded}', encodeURI(isFilterNeeded)),
            method: 'POST',
            headers,
            body: paginierungDTO,
        }, opts?.responseOpts);
    };

    /**
     * Lädt die Teilnehmer einer Abstimmung inkl. Dateien
     * GET TEILNEHMER+FILES (E)
     */
    getTeilnehmer({ id }: GetTeilnehmerRequest): Observable<TeilnehmerWithFilesEntityListResponseDTO>
    getTeilnehmer({ id }: GetTeilnehmerRequest, opts?: OperationOpts): Observable<AjaxResponse<TeilnehmerWithFilesEntityListResponseDTO>>
    getTeilnehmer({ id }: GetTeilnehmerRequest, opts?: OperationOpts): Observable<TeilnehmerWithFilesEntityListResponseDTO | AjaxResponse<TeilnehmerWithFilesEntityListResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'getTeilnehmer');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<TeilnehmerWithFilesEntityListResponseDTO>({
            url: '/abstimmung/{id}/teilnehmer'.replace('{id}', encodeURI(id)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Lädt den Teilnehmer einer Abstimmung
     * GET TEILNEHMER+FILES (E/T)
     */
    getTeilnehmer1({ id, userId }: GetTeilnehmer1Request): Observable<TeilnehmerWithFilesEntityResponseDTO>
    getTeilnehmer1({ id, userId }: GetTeilnehmer1Request, opts?: OperationOpts): Observable<AjaxResponse<TeilnehmerWithFilesEntityResponseDTO>>
    getTeilnehmer1({ id, userId }: GetTeilnehmer1Request, opts?: OperationOpts): Observable<TeilnehmerWithFilesEntityResponseDTO | AjaxResponse<TeilnehmerWithFilesEntityResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'getTeilnehmer1');
        throwIfNullOrUndefined(userId, 'userId', 'getTeilnehmer1');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<TeilnehmerWithFilesEntityResponseDTO>({
            url: '/abstimmung/{id}/teilnehmer/{userId}'.replace('{id}', encodeURI(id)).replace('{userId}', encodeURI(userId)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Liefert die Liste der Unterabstimmungen des Anwenders (»Meine Unterabstimmungen«).
     * Lädt Ersteller Unterabstimmungen.
     */
    getUnterabstimmungen({ isFilterNeeded, paginierungDTO }: GetUnterabstimmungenRequest): Observable<AbstimmungTableDTOs>
    getUnterabstimmungen({ isFilterNeeded, paginierungDTO }: GetUnterabstimmungenRequest, opts?: OperationOpts): Observable<AjaxResponse<AbstimmungTableDTOs>>
    getUnterabstimmungen({ isFilterNeeded, paginierungDTO }: GetUnterabstimmungenRequest, opts?: OperationOpts): Observable<AbstimmungTableDTOs | AjaxResponse<AbstimmungTableDTOs>> {
        throwIfNullOrUndefined(isFilterNeeded, 'isFilterNeeded', 'getUnterabstimmungen');
        throwIfNullOrUndefined(paginierungDTO, 'paginierungDTO', 'getUnterabstimmungen');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<AbstimmungTableDTOs>({
            url: '/abstimmung/unterabstimmungen/{isFilterNeeded}'.replace('{isFilterNeeded}', encodeURI(isFilterNeeded)),
            method: 'POST',
            headers,
            body: paginierungDTO,
        }, opts?.responseOpts);
    };

    /**
     * Erzeugt einen neuen Entwurf für eine Unterabstimmung
     * GET UNTERABSTIMMUNGSENTWURF
     */
    getUnterabstimmungsentwurf({ metadataId }: GetUnterabstimmungsentwurfRequest): Observable<AbstimmungEntityResponseDTO>
    getUnterabstimmungsentwurf({ metadataId }: GetUnterabstimmungsentwurfRequest, opts?: OperationOpts): Observable<AjaxResponse<AbstimmungEntityResponseDTO>>
    getUnterabstimmungsentwurf({ metadataId }: GetUnterabstimmungsentwurfRequest, opts?: OperationOpts): Observable<AbstimmungEntityResponseDTO | AjaxResponse<AbstimmungEntityResponseDTO>> {
        throwIfNullOrUndefined(metadataId, 'metadataId', 'getUnterabstimmungsentwurf');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<AbstimmungEntityResponseDTO>({
            url: '/abstimmung/unterabstimmungsentwurf/{metadataId}'.replace('{metadataId}', encodeURI(metadataId)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Ändert eine Abstimmung
     * PUT ABSTIMMUNG
     */
    modifyAbstimmung({ id, abstimmungEntityDTO }: ModifyAbstimmungRequest): Observable<AbstimmungEntityResponseDTO>
    modifyAbstimmung({ id, abstimmungEntityDTO }: ModifyAbstimmungRequest, opts?: OperationOpts): Observable<AjaxResponse<AbstimmungEntityResponseDTO>>
    modifyAbstimmung({ id, abstimmungEntityDTO }: ModifyAbstimmungRequest, opts?: OperationOpts): Observable<AbstimmungEntityResponseDTO | AjaxResponse<AbstimmungEntityResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'modifyAbstimmung');
        throwIfNullOrUndefined(abstimmungEntityDTO, 'abstimmungEntityDTO', 'modifyAbstimmung');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<AbstimmungEntityResponseDTO>({
            url: '/abstimmung/{id}'.replace('{id}', encodeURI(id)),
            method: 'PUT',
            headers,
            body: abstimmungEntityDTO,
        }, opts?.responseOpts);
    };

    /**
     * Beantwortet eine Anfrage
     * Anfrage beantworten (E)
     */
    modifyAnfrage({ anfrageId, anfrageEntityModifyDTO }: ModifyAnfrageRequest): Observable<void>
    modifyAnfrage({ anfrageId, anfrageEntityModifyDTO }: ModifyAnfrageRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    modifyAnfrage({ anfrageId, anfrageEntityModifyDTO }: ModifyAnfrageRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(anfrageId, 'anfrageId', 'modifyAnfrage');
        throwIfNullOrUndefined(anfrageEntityModifyDTO, 'anfrageEntityModifyDTO', 'modifyAnfrage');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/abstimmung/{anfrageId}/anfrage'.replace('{anfrageId}', encodeURI(anfrageId)),
            method: 'PUT',
            headers,
            body: anfrageEntityModifyDTO,
        }, opts?.responseOpts);
    };

    /**
     * Ändert die Rückmeldung des Bundeskanzleramtes
     * PUT RUECKMELDUNG BKAMT
     */
    modifyRueckmeldungBkAmt({ id, rueckmeldungType }: ModifyRueckmeldungBkAmtRequest): Observable<void>
    modifyRueckmeldungBkAmt({ id, rueckmeldungType }: ModifyRueckmeldungBkAmtRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    modifyRueckmeldungBkAmt({ id, rueckmeldungType }: ModifyRueckmeldungBkAmtRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'modifyRueckmeldungBkAmt');
        throwIfNullOrUndefined(rueckmeldungType, 'rueckmeldungType', 'modifyRueckmeldungBkAmt');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/abstimmung/{id}/rueckmeldung_bkamt/{rueckmeldungType}'.replace('{id}', encodeURI(id)).replace('{rueckmeldungType}', encodeURI(rueckmeldungType)),
            method: 'PUT',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Ändert die Rückmeldung des BMJs
     * PUT RUECKMELDUNG BMJ
     */
    modifyRueckmeldungBmj({ id, rueckmeldungType }: ModifyRueckmeldungBmjRequest): Observable<void>
    modifyRueckmeldungBmj({ id, rueckmeldungType }: ModifyRueckmeldungBmjRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    modifyRueckmeldungBmj({ id, rueckmeldungType }: ModifyRueckmeldungBmjRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'modifyRueckmeldungBmj');
        throwIfNullOrUndefined(rueckmeldungType, 'rueckmeldungType', 'modifyRueckmeldungBmj');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/abstimmung/{id}/rueckmeldung_bmj/{rueckmeldungType}'.replace('{id}', encodeURI(id)).replace('{rueckmeldungType}', encodeURI(rueckmeldungType)),
            method: 'PUT',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Beantwortet eine Abstimmung
     * Abstimmung beantworten (T)
     */
    modifyTeilnehmer({ id, teilnehmerEntityModifyDTO }: ModifyTeilnehmerRequest): Observable<TeilnehmerEntityResponseDTO>
    modifyTeilnehmer({ id, teilnehmerEntityModifyDTO }: ModifyTeilnehmerRequest, opts?: OperationOpts): Observable<AjaxResponse<TeilnehmerEntityResponseDTO>>
    modifyTeilnehmer({ id, teilnehmerEntityModifyDTO }: ModifyTeilnehmerRequest, opts?: OperationOpts): Observable<TeilnehmerEntityResponseDTO | AjaxResponse<TeilnehmerEntityResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'modifyTeilnehmer');
        throwIfNullOrUndefined(teilnehmerEntityModifyDTO, 'teilnehmerEntityModifyDTO', 'modifyTeilnehmer');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<TeilnehmerEntityResponseDTO>({
            url: '/abstimmung/{id}/teilnehmer'.replace('{id}', encodeURI(id)),
            method: 'PUT',
            headers,
            body: teilnehmerEntityModifyDTO,
        }, opts?.responseOpts);
    };

    /**
     * Beantwortet eine Anfrage
     * Anfrage beantworten (E)
     */
    modifyTeilnehmerRequest({ anfrageId, anfrageEntityModifyDTO }: ModifyTeilnehmerRequestRequest): Observable<void>
    modifyTeilnehmerRequest({ anfrageId, anfrageEntityModifyDTO }: ModifyTeilnehmerRequestRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    modifyTeilnehmerRequest({ anfrageId, anfrageEntityModifyDTO }: ModifyTeilnehmerRequestRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(anfrageId, 'anfrageId', 'modifyTeilnehmerRequest');
        throwIfNullOrUndefined(anfrageEntityModifyDTO, 'anfrageEntityModifyDTO', 'modifyTeilnehmerRequest');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/abstimmung/teilnahmeanfrage/{anfrageId}/modify'.replace('{anfrageId}', encodeURI(anfrageId)),
            method: 'PUT',
            headers,
            body: anfrageEntityModifyDTO,
        }, opts?.responseOpts);
    };

    /**
     * Setzt einen bereits vorhandenen Teilnehmer in CC (readonly)
     * Teilnehmer in CC setzen (E)
     */
    setTeilnehmerInCc({ id, userId }: SetTeilnehmerInCcRequest): Observable<void>
    setTeilnehmerInCc({ id, userId }: SetTeilnehmerInCcRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    setTeilnehmerInCc({ id, userId }: SetTeilnehmerInCcRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'setTeilnehmerInCc');
        throwIfNullOrUndefined(userId, 'userId', 'setTeilnehmerInCc');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/abstimmung/{id}/teilnehmer_in_cc/{userId}'.replace('{id}', encodeURI(id)).replace('{userId}', encodeURI(userId)),
            method: 'PUT',
            headers,
        }, opts?.responseOpts);
    };

}
